import './Viewer.scss';
import * as React from 'react';
import { Component } from 'react';
import { Log } from 'sarif';
import './extension';
export declare const FilterKeywordContext: React.Context<string>;
import { RunStore } from './RunStore';
import { IFilterState } from 'azure-devops-ui/Utilities/Filter';
interface ViewerProps {
    logs?: Log[];
    /**
     * Consider this the "initial" or "starting" state. This value is only applied once (during load).
     */
    filterState?: IFilterState;
    /**
     * The state applied when the user resets. If omitted, the default is:
     * ```javascript
     * {
     *     Baseline: { value: ['new', 'unchanged', 'updated'] },
     *     Suppression: { value: ['unsuppressed'] },
     * }
     * ```
     */
    defaultFilterState?: IFilterState;
    user?: string;
    hideBaseline?: boolean;
    hideLevel?: boolean;
    showSuppression?: boolean;
    showAge?: boolean;
    /**
     * When there are zero errors¹, show this message instead of just "No Results".
     * Intended to communicate definitive positive confidence since "No Results" may be interpreted as inconclusive.
     *
     * Note¹: If the (starting) `filterState` shows...
     * * Only errors (and hides warnings),
     *   then success is only communicated when there are zero errors (even if there exists warnings).
     * * Both errors and warnings,
     *   then success is communicated only when there are zero errors *and* zero warnings.
     * * Neither errors nor warnings,
     *   then the behavior is undefined. The current implementation will never communicate success.
     */
    successMessage?: string;
}
export declare class Viewer extends Component<ViewerProps> {
    private collapseComments;
    private filter;
    private groupByAge;
    constructor(props: any);
    warnOldVersion: boolean;
    _warnOldVersion: import("mobx").IReactionDisposer;
    private runStores;
    get runStoresSorted(): RunStore[];
    render(): JSX.Element;
}
export {};
